require 'spec_helper'

describe BFS do
  it "works" do
    start = 1
    generator = Proc.new do |state|
      new_states = if state.abs < 5
                     [state+2,state-1]
                   else
                     []
                   end
      new_states
    end
    @search = BFS.new(:start => start, :generator => generator)
    @search.run
    @search.path.should == [1,3]
    @search.run
    @search.path.should == [1,0]
    @search.run
    @search.path.should == [1,3,5]
    @search.run
    @search.path.should == [1,3,2]
    @search.run
    @search.path.should == [1,0,-1]
    @search.run
    @search.path.should == [1,3,2,4]
    @search.run
    @search.path.should == [1,0,-1,-2]
    @search.run
    @search.path.should == [1,3,2,4,6]
    @search.run
    @search.path.should == [1,0,-1,-2,-3]
  end
end
